<?PHP
/**
 * $Log: generic.php,v $
 * Revision 1.3  2004/06/09 14:37:44  services
 * - add authentification bypass for rt user .... (need a better solution)
 *
 * Revision 1.2  2004/04/19 12:10:49  seb
 * is_authorized : correction filtres recherches LDAP
 *

- error value in struct 0 -> -1
- ajout de la doc format phpDocumentor
 */

require_once 'lib/ws.inc.php';

/**
 * generic class for all related web services. 
 *
 * pour ajouter une mthode  un classe fille, il faut
 * la dclarer statiquement et galement dclarer une variable
 * du mme nom qui contriendra les informations relatives  la 
 * signature de la mthode.
 *
 * <code>
 * class wsc_ma_classe { 
 *
 * function &ma_fonction_statique($params)
 * // $params est de type XML_RPC_Message
 *
 * var $ma_fonction_statique = array(
 *                                   'sig' => array(array('type de retour',
 *                                                        'type du parametre1',
 *                                                         ...)),
 *                                   'doc' => 'description de la fonction'
 *                                   )
 *
 * }
 * </code>
 *
 * methods must be called statically. For each method there is
 * a corresponding array wich define method signature and a 
 * string doc which describes the aim of the method.
 * @package ws_server
 */
class wsc_generic{


    /**
     * as static class var are not available, this static method return the correct error
     * msg for a given type
     *
     * @public
     * @param string $type (string|int|struct|bool)
     * @return mixed error message in the given $type
     */    
   function &error($type){

       switch ($type) {

       case 'base64':
	   return "Vous n'etes pas autoris  accder  cette ressource";
       case 'int':
	   return -1;
       case 'struct':
	   return array(-1 => "Vous n'etes pas autoris  accder  cette ressource");
       case 'bool':
	   return FALSE;
       }    
   }

    /**
     * check if the given user is authorized to access this web service
     *
     * @param string $user is the user
     * @param array $groups of authorized groups
     * @return bool 
     */
    function &is_authorized($user, $groups){
	global $OPT;
	
	// FIXME: hardcode ws user (internal call within ws)
	if ($user == 'ws'){
	    return TRUE;
	}

	$user = trim($user);


	$customer_search = FALSE; // by default we don't do the search for customer eeid
	$ldap_conn = ldap_connect($OPT['ldap']['host'], $OPT['ldap']['port']);
	if ( $ldap_conn ) {
	    $ldap_bind = ldap_bind($ldap_conn);
	    if ( $ldap_bind ){
		
		$dn = 'ou=users,o=easter-eggs';
		// build filter
		$filter = '(&(uid='.$user.')(|';
		foreach ($groups as $group) {

		    if ($group == 'client'){
			$customer_search = TRUE;
			continue;
		    }
		    $filter .= '(ou='.$group.')';
		}
		$filter .= '))';

//		$filter = '(&(uid=sperson)(|(ou=dev)))';
		$search_result = ldap_search($ldap_conn, $dn, $filter);
		
		$info = ldap_get_entries($ldap_conn, $search_result);
		if ($info['count'])
		    return TRUE;


		// refaire les recherches pour les clients .... ou=customers (uid=$user et groups=client)
		if ($customer_search){
		    $info = '';	// reset previous result
		    $dn = 'ou=customers,o=easter-eggs' ;
		    $filter ='(|(uid='.$user.')(mail='.$user.'))';
		    $search_result = ldap_search($ldap_conn, $dn, $filter);
		    $info = ldap_get_entries($ldap_conn, $search_result);
		    if ($info['count'])
			return TRUE;
		}
	    }
	    ldap_close($ldap_conn);
	}
	return FALSE;
    }


    /**
     * check if the given user has the right eeAllowedServices attribute or is
     * member of the tech group
     *
     * @param string $user is the user
     * @param string $service is the service
     * @return bool 
     */
    function &check_acl_service($user, $service){
	global $OPT;
	
	$user = trim($user);

	$ldap_conn = ldap_connect($OPT['ldap']['host'], $OPT['ldap']['port']);
	if ( $ldap_conn ) {
	    $ldap_bind = ldap_bind($ldap_conn);
	    if ( $ldap_bind ){
		
		$dn = 'ou=users,o=easter-eggs';

		// build the filter
		$filter  = '(&(uid='.$user.')(|';
        $filter .= '(eeAllowedServices='.$service.'*)';
        $filter .= '(ou=tech)';
        $filter .= '))';

		$search_result = ldap_search($ldap_conn, $dn, $filter);
		
		$info = ldap_get_entries($ldap_conn, $search_result);
		if ($info['count'])
		    return TRUE;
	    }
	    ldap_close($ldap_conn);
	}
	return FALSE;
    }


    /**
     * check if the given user has the right eeAllowedServices attribute or is
     * member of the tech group
     *
     * @param string $user is the user
     * @param string $service is the service
     * @return bool 
     */
    function &check_acl_service_customer($user, $service, $customer){
	global $OPT;
	
	$user = trim($user);

	$ldap_conn = ldap_connect($OPT['ldap']['host'], $OPT['ldap']['port']);
	if ( $ldap_conn ) {
	    $ldap_bind = ldap_bind($ldap_conn);
	    if ( $ldap_bind ){
		
		$dn = 'ou=users,o=easter-eggs';

		// build filter
		$filter = '(&(uid='.$user.')(eeAllowedServices='.$service.'::'.$custmer.'))';

		$search_result = ldap_search($ldap_conn, $dn, $filter);
		
		$info = ldap_get_entries($ldap_conn, $search_result);
		if ($info['count'])
		    return TRUE;
	    }
	    ldap_close($ldap_conn);
	}
	return FALSE;
    }

    
    function &get_acl_service_customer($user, $service){
	global $OPT;
	
	$user = trim($user);

	$ldap_conn = ldap_connect($OPT['ldap']['host'], $OPT['ldap']['port']);
	if ($ldap_conn) {
	    $ldap_bind = ldap_bind($ldap_conn);

	    if ($ldap_bind) {
		    $dn = 'ou=users,o=easter-eggs';

    		// build the filter
	    	$filter  = '(&(uid='.$user.')(|';
            $filter .= '(eeAllowedServices='.$service.'*)';
            $filter .= '(ou=tech)';
            $filter .= '))';

		    $search_result = ldap_search($ldap_conn, $dn, $filter);
    		$entries       = ldap_get_entries($ldap_conn, $search_result);
	        ldap_close($ldap_conn);

            // Only one user must match
		    if ($entries['count'] == 1) {

                // Is the user member of the tech group
                $ou = $entries[0]['ou'];
                for ($i = 0; $i < $ou['count']; $i++) {
                    if ($ou[$i] == 'tech') {
                        return True;
                    }
                }

                // Is the user has the right eeAllowedServices attribute
                $allowedservices = $entries[0]['eeallowedservices'];

                // Parsing allowed services for the user
                $acl_customers = Array();
                for ($i = 0; $i < $allowedservices['count']; $i++) {
                    
                    // The user has full access to service
                    if ($allowedservices[$i] == $service) {
                        return true;

                    // The user 
                    } else {
                        $exp = explode($service . '::', $allowedservices[$i]);
                        if (!$exp[0] == $allowedservices[$i]) {
                            array_push($acl_customers, $exp[1]);
                        }
                    }

                }

                return $acl_customers;
            }

        }

    }

	return FALSE;
    }


} // end of class



?>
